SystemOrganization addCategory: #tp1!
SystemOrganization addCategory: #Tp1!
SystemOrganization addCategory: #'Tp1-Test'!

Trait named: #FojaAcademica
	uses: {}
	category: 'Tp1'!

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:23'!
cantidadDeAbandonadas

	^ (self filtrarAuscentes: (self obtenerNotas)) size.! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:23'!
cantidadDeAprobadas

	^ (self filtrarAprobados: (self obtenerNotas)) size.! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:35'!
cuantasNotasCon: unaNota


	^(self obtenerNotas select: [ :cadaNota | cadaNota = unaNota ]) size.! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 23:36'!
cuantasNotasMayorOIgual: unaNota


	^(self obtenerNotas select: [ :cadaNota | cadaNota >= unaNota ]) size.! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:24'!
filtrarAbandono: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem = -1 ]).
	! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:23'!
filtrarAprobados: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem > 3 ]).
	! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:26'!
filtrarDesaprobados: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem < 4 & unElem > -1 ]).
	! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:24'!
filtrarPresentes: unaColeccion

	^ (unaColeccion select: [ :unElem | unElem > -1 ]).
	! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 23:41'!
notaMasAltaNVeces: nVeces

	
	| colecciontemp |
	colecciontemp := {10. 9. 8. 7. 6. 5. 4. 3. 2. 1. 0}.


	colecciontemp do:[ :unaNota | (self cuantasNotasMayorOIgual: unaNota >= nVeces ) ifTrue: [ ^ unaNota  ] ifFalse: [unaNota  = 0 ifTrue: [^ 'No habia notas suficientes']  ] ]. ! !

!FojaAcademica methodsFor: 'Requirements' stamp: 'JulianGalati 9/10/2013 21:34'!
obtenerNotas 

self requiredMethods. 

! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:31'!
porcentajeDeAprobadosSobreIniciados

	^ ((self filtrarAprobados: (self obtenerNotas) ) /  (self obtenerNotas size) )* 100! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:27'!
promedioConAplazos 

	^ (self filtrarPresentes:  (self obtenerNotas)) average.! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:28'!
promedioSinAplazos 

	^ (self filtrarAprobados:  (self obtenerNotas)) average.! !

!FojaAcademica methodsFor: 'Trait-FojaAcademica' stamp: 'JulianGalati 9/10/2013 22:34'!
tablaNotas
	|colecciontemp coleccionReturn |

	colecciontemp := {0. 1. 2. 3. 4. 5. 6. 7. 8. 9. 10}.
	coleccionReturn := Dictionary  new.
	colecciontemp 	do: [ :x |  coleccionReturn at: x put: (self cuantasNotasCon: x)].
	^coleccionReturn! !

Object subclass: #Alumno
	uses: FojaAcademica
	instanceVariableNames: 'legajo nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Alumno class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Alumno class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:05'!
new:  nombreA legajo:legajoA
	
	|unAlumno|
	
	unAlumno :=Alumno new.
	
	unAlumno  legajo: legajoA.
	unAlumno  nombre: nombreA.
	unAlumno  cursos: Bag new.
	
	^ unAlumno .! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos
	^ cursos! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos: anObject
	cursos := anObject! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo
	^ legajo! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo: anObject
	legajo := anObject! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre
	^ nombre! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre: anObject
	nombre := anObject! !

!Alumno methodsFor: 'Domain' stamp: 'macha 9/10/2013 15:13'!
obtenerNotas
	"comment stating purpose of message"
	
	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	cursos do:[:unCurso | listaDeNotas add: (unCurso alumnos at: self nombre)  ].
	^listaDeNotas.
	! !

Object subclass: #AlumnoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Test'!

Object subclass: #Carrera
	uses: FojaAcademica
	instanceVariableNames: 'nombre materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Carrera class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Carrera class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:06'!
new: nombreCarreraParam

	|unaCarrera|

	unaCarrera :=Carrera new.
	unaCarrera  nombre: nombreCarreraParam.
	unaCarrera  materias: Bag new.
	^unaCarrera.! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
materias
	^ materias! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
materias: anObject
	materias := anObject! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
nombre
	^ nombre! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
nombre: anObject
	nombre := anObject! !

!Carrera methodsFor: 'Domain' stamp: 'JulianGalati 9/11/2013 00:47'!
obtenerNotas

	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	
	materias do: [ :unaMateria | listaDeNotas := (unaMateria  obtenerNotas , listaDeNotas)].
	
	^ listaDeNotas.! !

!Carrera methodsFor: 'testing' stamp: 'macha 9/8/2013 23:25'!
testInicializar
	"comment stating purpose of message"

	| listaAlumnos |
	
	cursos := OrderedCollection  new.
	cursos add: (Curso new:'Paradigmas').
	cursos add: (Curso new:'TADP').
	alumnos at:'macha' put:(Alumno new:'macha' legajo:1378259).
	alumnos at:'diego' put:(Alumno new:'diego' legajo:1378253).
	alumnos at:'julian' put:(Alumno new:'julian' legajo:1378255).
	alumnos at:'pedro`' put:(Alumno new:'pedro' legajo:1378251).

	cursos do:[:unCurso | unCurso testInicializar. unCurso alumnosRef: ((unCurso alumnosRef)  union: alumnos) . alumnos do: [:unAlumno |   (unAlumno cursos) add: unCurso ]].! !

Object subclass: #CarreraTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Test'!

!CarreraTest class methodsFor: 'Scenario' stamp: 'macha 9/11/2013 10:43'!
crearCarreraCon2Materias1CursoCadaUna3Alumnos3Docentes 

	"Este metodo crea un escenario en el cual hay una carrera (Ingenieria en sistemas), que tiene 2 materias (TADP y PDEP) las cuales tiene un curso cada una. TADP tiene 2 docentes (franco y demian) y PDEP tambien (franco y alf). Por ultimo, TADP tiene 3 alumnos (ramiro, julian y diego que se sacaron -1 (ausente), 8 y 3 respectivamente) y PDEP tiene 2 alumnos (ramiro y diego que se sacaron 2 y 8 respectivamente)"
	| ingenieriaEnSistemas  unDocente unAlumno unCurso unaMateria listaDeAlumnos listaDeDocentes|
	
	ingenieriaEnSistemas := Carrera new: 'Ingenieria en Sistemas'.	
	listaDeAlumnos:= Bag new.
	listaDeDocentes:= Bag new.

	"Alumnos del curso"	
	unAlumno := Alumno new:'Ramiro Machado' legajo:1415700.
	listaDeAlumnos  add: unAlumno.
	unAlumno := Alumno new:'Diego Salomon' legajo:1378259.
	listaDeAlumnos  add: unAlumno.

	"Docentes del curso"		
	unDocente := Docente new:'Franco Bulgarelli'.
	listaDeDocentes add: unDocente.
	unDocente := Docente new:'Demian Alonso'.
	listaDeDocentes add: unDocente.

	"Creando del curso, poniendo notas, creando la materia, asignando el curso y poniendo la materia en la carrera"	
	unCurso:= Curso new:2012 docentes: listaDeDocentes  alumnos: listaDeAlumnos. 
	unCurso notas at:1415700 put:2.
	unCurso notas at:1378259 put:8.
	unaMateria := Materia new: 'PDEP'.
	unaMateria cursos add: unCurso.
	ingenieriaEnSistemas materias add: unaMateria.	
	
	
	
	"Alumnos del curso"	
	unAlumno := Alumno new:'Julian Galati' legajo:1405317.
	listaDeAlumnos  add: unAlumno.

	"Docentes del curso"		
	listaDeDocentes remove: unDocente.
	unDocente := Docente new:'Alfredo Sanzo'.
	listaDeDocentes add: unDocente.


	"Creando del curso, poniendo notas, creando la materia, asignando el curso y poniendo la materia en la carrera"	
	unCurso:= Curso new:2013 docentes: listaDeDocentes  alumnos: listaDeAlumnos. 
	unCurso notas at:1415700 put: -1.
	unCurso notas at:1378259 put:3.
	unCurso notas at:1405317 put:8.
	unaMateria := Materia new: 'TADP'.
	unaMateria cursos add: unCurso.
	ingenieriaEnSistemas materias add: unaMateria.
	
	^ ingenieriaEnSistemas.! !

!CarreraTest methodsFor: 'Scene' stamp: 'macha 9/11/2013 11:45'!
crearCarreraCon2Materias1CursoCadaUna3Alumnos3Docentes

	"Este methodo crea un escenario y devuelve una carrera (Ingenieria en Sistemas) con 2 materias (TADP y PEDP) las cuales tiene un curso cada una. TADP tiene 2 de los docentes (franco y demian ) y PDEP tambien tiene 2 (franco y alf). Por ultimo hay 3 alumnos (ramiro y diego se sacaron 2 y 8 respectivamente en PDEP y ramiro,diego y julian se sacaron 4, -1 y 6 respectivamente en PDEP)"
	

	| ingenieriaEnSistemas |
	ingenieriaEnSistemas:=  Carrera new.
	

	^ ingenieriaEnSistemas.! !

Object subclass: #Curso
	uses: FojaAcademica
	instanceVariableNames: 'docentes notas anio alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Curso class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Curso class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:24'!
new: unAnio docentes: listaDeDocentes alumnos: listaDeAlumnos

	|unCurso|
	unCurso:=Curso new.
	unCurso anio: unAnio.
	unCurso docentes: listaDeDocentes.
	unCurso alumnos: listaDeAlumnos.
	unCurso notas: Dictionary new.
	
	listaDeDocentes do: [ :unDocente | (unDocente cursos) add: self].	
	listaDeAlumnos do: [ :unAlumno | (unAlumno cursos) add: self].
	
	^ unCurso.! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
alumnos
	^ alumnos! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
alumnos: anObject
	alumnos := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
anio
	^ anio! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
anio: anObject
	anio := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
docentes
	^ docentes! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
docentes: anObject
	docentes := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
notas
	^ notas! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
notas: anObject
	notas := anObject! !

!Curso methodsFor: 'Domain' stamp: 'macha 9/10/2013 15:14'!
obtenerNotas
	
	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	alumnos do:[:unaNota | listaDeNotas add: unaNota ].
	^listaDeNotas.
	! !

!Curso methodsFor: 'testing' stamp: 'macha 9/8/2013 23:26'!
testInicializar
	alumnos:= Dictionary new.
	alumnosRef:= OrderedCollection new.
	
	alumnos at: 'macha' put: 5.
	alumnos at: 'diego' put: 8. 
	alumnos at: 'julian' put: 2. 
	alumnos at: 'pedro' put: -1. 
! !

Object subclass: #CursoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Test'!

Object subclass: #Docente
	uses: FojaAcademica
	instanceVariableNames: 'cursos nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Docente class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Docente class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:10'!
new: nombreDocente

	| unDocente |
	
	unDocente := Docente new.
	unDocente nombre: nombreDocente.
	unDocente cursos: Bag new.
	^ unDocente.! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos
	^ cursos! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos: anObject
	cursos := anObject! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre
	^ nombre! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre: anObject
	nombre := anObject! !

!Docente methodsFor: 'Domain' stamp: 'JulianGalati 9/11/2013 00:44'!
obtenerNotas
	"comment stating purpose of message"
	
	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	cursos do:[:unCurso | listaDeNotas := listaDeNotas , unCurso obtenerNotas ].
	^listaDeNotas.
	! !

Object subclass: #DocenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Test'!

Object subclass: #Materia
	uses: FojaAcademica
	instanceVariableNames: 'cursos nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Materia class
	uses: FojaAcademica classTrait
	instanceVariableNames: ''!

!Materia class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:11'!
new: nombreMateria

	| unaMateria |
	
	unaMateria := Materia new.
	unaMateria nombre: nombreMateria.
	unaMateria cursos: Bag new.
	^ unaMateria.! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos
	^ cursos! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos: anObject
	cursos := anObject! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre
	^ nombre! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre: anObject
	nombre := anObject! !

!Materia methodsFor: 'Domain' stamp: 'JulianGalati 9/11/2013 00:48'!
obtenerNotas

	|listaDeNotas|
	
	listaDeNotas := OrderedCollection new.
	
	cursos do: [ :unCurso | listaDeNotas := (unCurso  obtenerNotas , listaDeNotas)].
	
	^ listaDeNotas.! !

Object subclass: #MateriaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Test'!
